import { Component } from 'react'
import { View, Text, Button, Image, ScrollView, Input } from '@tarojs/components'
import * as api from '../../service/index'
import tool from '../../common/tool'
import Taro, { } from '@tarojs/taro'
import './index.less'

export default class collection extends Component {
  state = {
    tags: [],//标签列表
    tagsIndex: 0,//当前的标签
    booksList: [],//分类书籍
    page: 1,
    page_size: 20,
    isNext: true,//是否还有下一页
  }

  componentWillMount () {
    this.getBookCatIndex()
  }
  componentDidShow () {
  }
  getBookCatIndex () {
    api.getBookCatIndex().then(res => {
      if (res.code == 200) {

        this.setState({
          tags: res.data.book_cat,

        }, () => {
          this.getBookCatInfo()
        })
      }
    })
  }
  getBookCatInfo () {
    let params = {
      cat_id: this.state.tags[this.state.tagsIndex].id,
      page: this.state.page,
      page_size: this.state.page_size,
    }
    api.getBookCatInfo(params).then(res => {
      if (res.code == 200) {
        let isNext = true
        console.log(res.data.book_cat.length, 'res.data.book_cat.length');
        if (res.data.book_cat.length < 20) {
          isNext = false
        }
        this.setState({
          booksList: [...this.state.booksList, ...res.data.book_cat],
          isNext: isNext,
          page: isNext ? this.state.page + 1 : this.state.page
        })
      }
    })
  }
  toSearch () {
    Taro.navigateTo({
      url: '/pages/index/subpages/search/index'
    })
  }
  selectedLabel (item, index) {
    this.setState({
      tagsIndex: index,
      booksList: [],
      page: 1
    }, () => {
      this.getBookCatInfo()
    })
  }
  onReachBottom () {
    console.log(this.state.isNext, 'this.state.isNext');
    if (this.state.isNext) {
      this.getBookCatInfo()
    }
  }
  toDetail (item, index) {
    Taro.navigateTo({
      url: `/pages/index/subpages/novel/index?book_id=${item.id}`
    })
  }
  toMoneyPlay () {
    Taro.navigateTo({
      url: `/pages/mine/subpages/moneyPlay/index`
    })
  }


  render () {
    return (
      <View className='mine'>
        <View className='mine-content'>
          <View className='search' onClick={e => (this.toSearch())}>
            <Image className='search-img' src='https://video-img.fyshark.com/1683600195067ahjdklj.png'></Image>
            <Input className='search-input' disabled type='text' placeholder='请输入书名/口令码' focus />
          </View>
          <ScrollView
            className='recharge'
            scrollX
          >
            {
              this.state.tags.map((item, index) => (
                <View className='recharge-list' onClick={e => (this.selectedLabel(item, index))} key={index}>
                  <View className={this.state.tagsIndex == index ? 'recharge-info-active' : 'recharge-info'}
                    key={index}
                  >
                    {item.name}
                  </View>
                  {
                    this.state.tagsIndex == index &&
                    <View className='recharge-tips'></View>
                  }
                </View>
              ))
            }
          </ScrollView>
          <View className='book-content'>
            <View className='book-list'>
              {
                this.state.booksList.map((item, index) => (
                  <View className='book-info' key={index} onClick={e => (this.toDetail(item, index))}>
                    <View className='book-info-left'>
                      <Image className='book-img' src={item.img}></Image>
                    </View>
                    <View className='book-right'>
                      <View className='book-title'>{item.name}</View>
                      <View className='book-tips'>{tool.ellipsis(item.intro, 56)}</View>
                      <View className='book-label-list'>
                        {
                          item.name_tag.length > 0 &&
                          <View className='book-label-info'>
                            {item.name_tag}
                          </View>
                        }
                      </View>
                    </View>
                  </View>
                ))
              }
            </View>
          </View>
        </View>
        <View className='share update-active' onClick={e => (this.toMoneyPlay())}>
          <Image className='share-img' mode='widthFix' src='https://video-img.fyshark.com/1684494291916shjkgnla.png'></Image>
        </View>
      </View>
    )
  }
}
