import { Component } from 'react'
import { View, Text, Button, Image, scrollView, RichText, Input } from '@tarojs/components'
import * as api from '../../../../service/index'
import tool from '../../../../common/tool'
import Taro, { getCurrentInstance } from '@tarojs/taro'
import './index.less'
import { AtDrawer } from 'taro-ui'
import "taro-ui/dist/style/components/drawer.scss";

export default class collection extends Component {
  $instance = getCurrentInstance()
  state = {
    directoryList: [
    ],
    show: true,
    order_by_sta: 0,//0:正序，1:倒序

  }

  componentWillMount () {
    this.getBookCatalogue()
  }
  componentDidShow () {
  }
  getBookCatalogue () {
    let routers = this.$instance.router.params
    api.getBookCatalogue({ book_id: routers.book_id, order_by_sta: this.state.order_by_sta }).then(res => {
      if (res.code == 200) {
        this.setState({
          directoryList: res.data.book_catalogue,
        })
      }
    })
  }
  changeOrderBySta () {
    this.setState({
      order_by_sta: this.state.order_by_sta == 0 ? 1 : 0
    }, () => {
      this.getBookCatalogue()
    })
  }
  toNovelText (item, index) {
    api.bookReadReort({ content_id: item.id }).then(res => {
      if (res.code == 200) {
        let routers = this.$instance.router.params
        Taro.navigateTo({
          url: `/pages/index/subpages/novelText/index?book_id=${routers.book_id}`
        })
      }
    })
  }


  render () {
    return (
      <View className='mine'>
        <View className='mine-content'>
          <View className='drawer-content'>
            <View className='drawer-over'>
              <View className='drawer-over-num'>共{this.state.directoryList.length}章</View>
              <View className='drawer-over-right' onClick={e => (this.changeOrderBySta())}>
                <View className='drawer-over-right-title'>倒序</View>
                <Image className='drawer-over-right-img' src='https://video-img.fyshark.com/1683631467893djaj.png'></Image>
              </View>
            </View>
            <View className='drawer-list'>
              {
                this.state.directoryList.map((item, index) => (
                  <View className='drawer-info' key={index} onClick={e => (this.toNovelText(item, index))}>
                    <View className='drawer-info-left'>{item.name}</View>
                    {
                      item.is_vip == 1 &&
                      <Image className='drawer-info-right' src='https://video-img.fyshark.com/1683633924768dsjkmalnjdl.png'></Image>
                    }
                  </View>
                ))
              }
            </View>
          </View>
        </View>
      </View>
    )
  }
}
