import { Component } from 'react'
import { View, Text, Button, Image, scrollView, Input } from '@tarojs/components'
import * as api from '../../../../service/index'
import tool from '../../../../common/tool'
import Taro, { } from '@tarojs/taro'
import './index.less'

export default class collection extends Component {
  state = {
    booksList: [],
  }

  componentWillMount () {
    this.getBookSearch('')
  }
  componentDidShow () {
  }
  search (e) {
    this.getBookSearch(e.detail.value)
  }
  getBookSearch (input_str) {
    api.getBookSearch({ input_str: input_str }).then(res => {
      if (res.code == 200) {
        this.setState({
          booksList: res.data.book_search
        })
      }
    })
  }
  onReachBottom () {
    // if (!this.state.total) {
    //   this.setState({
    //     page: this.state.page + 1
    //   })
    // }
  }
  toDetail (item, index) {
    Taro.navigateTo({
      url: `/pages/index/subpages/novel/index?book_id=${item.id}`
    })
  }

  render () {
    return (
      <View className='mine'>
        <View className='mine-content'>
          <View className='search'>
            <Image className='search-img' src='https://video-img.fyshark.com/1683600195067ahjdklj.png'></Image>
            <Input className='search-input' onInput={e => (this.search(e))} type='text' placeholder='请输入书名/口令码' focus />
          </View>
          <View className='search-title'>热门推荐</View>
          <View className='book-content'>
            {
              this.state.booksList.length > 0 &&
              <View className='book-list'>
                {
                  this.state.booksList.map((item, index) => (
                    <View className='book-info' key={index} onClick={e => (this.toDetail(item, index))}>
                      <View className='book-info-left'>
                        <Image className='book-img' src={item.img}></Image>
                      </View>
                      <View className='book-right'>
                        <View className='book-title'>{item.name}</View>
                        <View className='book-tips'>{tool.ellipsis(item.intro, 56)}</View>
                        <View className='book-label-list'>
                          {
                            item.name_tag.length > 0 &&
                            <View className='book-label-info'>
                              {item.name_tag}
                            </View>
                          }
                        </View>
                      </View>
                    </View>
                  ))
                }
              </View>
            }
          </View>
        </View>
      </View>
    )
  }
}
