import { Component } from 'react'
import { View, Text, Button, Image, scrollView, Input } from '@tarojs/components'
import * as api from '../../../../service/index'
import tool from '../../../../common/tool'
import Taro, { } from '@tarojs/taro'
import './index.less'

export default class collection extends Component {
  state = {
    bookList: [],
    isEdit: false,
    isOverSelect: false
  }

  componentWillMount () {
  }
  componentDidShow () {
    this.myBookRead()
  }
  onReachBottom () {
    // if (!this.state.total) {
    //   this.setState({
    //     page: this.state.page + 1
    //   })
    // }
  }
  myBookRead () {
    api.myBookRead().then(res => {
      if (res.code == 200) {
        this.setState({
          bookList: res.data
        })
      }
    })
  }
  changeEdit () {
    this.setState({
      isEdit: true
    })
  }
  cancelEdit () {
    let _bookList = this.state.bookList
    _bookList.forEach((item, index) => {
      item.isSelect = false
    })
    this.setState({
      bookList: _bookList,
      isOverSelect: false,
      isEdit: false
    })
  }
  deleteEdit () {
    let that = this
    Taro.showModal({
      title: '提示',
      content: '确定删除吗？',
      success: function (res) {
        if (res.confirm) {
          let book_ids = []
          that.state.bookList.forEach(item => {
            if (item.isSelect) {
              book_ids.push(item.book_id)
            }
          })

          api.deleteBookRead({ book_ids: book_ids.toString() }).then(res => {
            if (res.code == 200) {
              that.myBookRead()
              that.setState({
                isEdit: false,
                isOverSelect: false
              })
            }
          })
        } else if (res.cancel) {
          console.log('用户点击取消')
        }

      }
    })

  }
  overSelect () {
    let _bookList = this.state.bookList
    _bookList.forEach((item, index) => {
      item.isSelect = !this.state.isOverSelect
    })
    this.setState({
      bookList: _bookList,
      isOverSelect: !this.state.isOverSelect,
    })
  }
  changeSelect (item, index) {
    if (!this.state.isEdit) return
    let _bookList = this.state.bookList
    _bookList.forEach((item, i) => {
      if (index == i) {
        item.isSelect = !this.state.bookList[index].isSelect
      }
    })

    this.setState({
      bookList: _bookList
    }, () => {
      let list = this.state.bookList.filter(res => {
        return !res.isSelect
      })
      if (list.length == 0) {
        this.setState({
          isOverSelect: true
        })
      } else {
        this.setState({
          isOverSelect: false
        })
      }
    })
  }
  toDetail (item, index) {
    if (this.state.isEdit) {
      let _bookList = this.state.bookList
      _bookList.forEach((item, i) => {
        if (index == i) {
          item.isSelect = !this.state.bookList[index].isSelect
        }
      })

      this.setState({
        bookList: _bookList
      }, () => {
        let list = this.state.bookList.filter(res => {
          return !res.isSelect
        })
        if (list.length == 0) {
          this.setState({
            isOverSelect: true
          })
        } else {
          this.setState({
            isOverSelect: false
          })
        }
      })
    } else {
      Taro.navigateTo({
        url: `/pages/index/subpages/novelText/index?book_id=${item.book_id}`
      })
    }
  }

  render () {
    return (
      <View className='mine'>
        {
          this.state.bookList.length == 0 ?
            <View className='empty'>
              <Image className='empty-img' src='https://video-img.fyshark.com/1683801289275slsll.png'></Image>
              <View className='empty-tips'>暂时还没有阅读记录哦！</View>
            </View>
            :
            <View className='mine-content'>
              {
                !this.state.isEdit ?
                  <View className='edit'>
                    <View className='edit-content' onClick={e => (this.changeEdit())}>
                      <Image className='edit-img' src='https://video-img.fyshark.com/1683687193883dhksjn.png'></Image>
                      编辑
                    </View>
                  </View>
                  :
                  <View className='select'>
                    <View className='select-content' onClick={e => (this.overSelect())}>
                      <Image className='select-img' src={this.state.isOverSelect ? 'https://video-img.fyshark.com/1683698925516hnakjl.png' : 'https://video-img.fyshark.com/1683698074122dhkahj.png'}></Image>
                      全选
                    </View>
                  </View>
              }
              <View className='book-content'>
                <View className='book-list'>
                  {
                    this.state.bookList.map((item, index) => (
                      <View className='book-info' key={index} onClick={e => (this.toDetail(item, index))}>
                        <View className='book-info-left'>
                          <Image className='book-img' src={item.img}></Image>
                          {
                            this.state.isEdit &&
                            <Image className='select-icon' src={item.isSelect ? 'https://video-img.fyshark.com/1683699004116sihel.png' : 'https://video-img.fyshark.com/1683698064582dhka.png'}></Image>
                          }
                        </View>
                        <View className='book-right'>
                          <View className='book-title'>{item.name}</View>
                          <View className='book-tips'>{tool.ellipsis(item.album_name, 56)}</View>
                        </View>
                      </View>
                    ))
                  }
                </View>
              </View>
              {
                this.state.isEdit &&
                <View className='edit-console'>
                  <View className='console'>
                    <View className='cancellation' onClick={e => (this.cancelEdit())}>取消</View>
                    <View className='delete' onClick={e => (this.deleteEdit())}>删除</View>
                  </View>
                </View>
              }
            </View>
        }
      </View>
    )
  }
}
