import { Component } from 'react'
import { View, Text, Button, Image, scrollView, Input } from '@tarojs/components'
import * as api from '../../../../service/index'
import tool from '../../../../common/tool'
import Taro, { } from '@tarojs/taro'
import './index.less'

export default class collection extends Component {
  state = {
    earningslist: [],//收益详情
    add_sum: 0,//累计收益
    already_sum: 0,//已提取收益
    now_sum: 0,//可提现金额
    extract_status: 0,
    page: 1,
    page_size: 20,
    isNext: true,//是否还有下一页
  }

  componentWillMount () {
    this.getEarningsInfo()
  }
  componentDidShow () {
  }
  getEarningsInfo () {
    let params = {
      page: this.state.page,
      page_size: this.state.page_size,
    }
    api.getEarningsInfo(params).then(res => {
      if (res.code == 200) {
        let isNext = true
        console.log(res.data.earningslist.length, 'res.data.book_cat.length');
        if (res.data.earningslist.length < 20) {
          isNext = false
        }
        this.setState({
          earningslist: [...this.state.earningslist, ...res.data.earningslist],
          add_sum: res.data.add_sum,
          already_sum: res.data.already_sum,
          now_sum: res.data.now_sum,
          extract_status: res.data.extract_status,
          isNext: isNext,
          page: isNext ? this.state.page + 1 : this.state.page
        })
      }
    })
  }
  withdrawal () {
    if (this.state.extract_status == 2) {
      Taro.showToast({
        title: `目前已有提现金额在审核中...`,
        icon: 'none',
      });
      return
    }
    Taro.navigateTo({
      url: '/pages/mine/subpages/withdrawal/index'
    })
  }
  onReachBottom () {
    if (this.state.isNext) {
      this.getEarningsInfo()
    }
  }

  render () {
    return (
      <View className='mine'>
        <View className='make-info'>
          <View className='make-info-top'>
            <View className='make-info-top-left'>
              <View className='make-info-title'>目前可提取总金额（元）</View>
              <View className='make-info-money'>{this.state.now_sum / 100}</View>
            </View>
            {
              this.state.extract_status != 4 &&
              <View className='make-info-top-right' onClick={e => (this.withdrawal())}>{this.state.extract_status == 2 ? '审核中' : '提现'}</View>
            }
          </View>
          <View className='make-info-bottom'>
            <View className='make-info-bottom-left'>
              <View className='make-all-money-title'>累计收益（元）</View>
              <View className='make-all-money-num'>{this.state.add_sum / 100}</View>
            </View>
            <View className='make-info-bottom-right'>
              <View className='withdrawal-title'>已提现金额（元）</View>
              <View className='withdrawal-num'>{this.state.already_sum / 100}</View>
            </View>
          </View>
        </View>
        <View className='income'>
          <View className='income-title'>收益详情</View>
          <View className='income-list'>
            {
              this.state.earningslist.map((item, index) => (
                <View className='income-info' key={index}>
                  <View className='income-left'>
                    <View className='income-info-title'>{item.money_name}</View>
                    <View className='income-date'>{item.time}</View>
                  </View>
                  <View className='income-right' style={item.earnings_type == 0 ? 'color: #84f121' : 'color: #f13921;'}>{item.earnings_type == 0 ? '+' : '-'}{item.money / 100}</View>
                </View>
              ))
            }
          </View>
          <View className='income-tips'>已经到底啦</View>
        </View>
      </View >
    )
  }
}
