import { Component } from 'react'
import { View, Text, Button, Image, scrollView, Input } from '@tarojs/components'
import * as api from '../../../../service/index'
import tool from '../../../../common/tool'
import Taro, { } from '@tarojs/taro'
import './index.less'

export default class collection extends Component {
  state = {
    my_code: "",//邀请码
    my_role_name: "普通用户",
    my_role_status: 0,
    team_sum: 0
  }

  componentWillMount () {
  }
  componentDidShow () {
    this.getTeamInfo()

  }
  getTeamInfo () {
    api.getTeamInfo().then(res => {
      if (res.code == 200) {
        this.setState({
          my_code: res.data.my_code,
          my_role_name: res.data.my_role_name,
          my_role_status: res.data.my_role_status,
          team_sum: res.data.team_sum
        })
      }
    })
  }
  teamEnqueue () {
    let that = this
    if (this.state.my_role_status == 0) {
      tt.getUserInfo({
        withCredentials: true,
        success (item) {
          let params = {
            user_img: item.userInfo.avatarUrl,
            user_name: item.userInfo.nickName
          }
          api.modifyUser(params).then(item => {
            if (item.code == 200) {
              api.teamEnqueue({ input_str: that.state.my_code }).then(res => {
                if (res.code == 200) {
                  that.getTeamInfo()
                } else {
                  Taro.showToast({ icon: 'none', title: res.msg });
                }
              })
            }
          })
        },
        fail (res) {
          Taro.showToast({ icon: 'none', title: '团队绑定失败！' });
        },
      });

    } else {
      Taro.setClipboardData({
        data: this.state.my_code,
        success: function (res) {
          Taro.showToast({ icon: 'none', title: '邀请码复制成功' });
        }
      })
    }
  }
  search (e) {
    console.log(e);
    this.setState({
      my_code: e.detail.value
    })
  }


  render () {
    return (
      <View className='mine'>
        <View className='content'>
          {
            this.state.my_role_status == 0 ?
              <View>
                <View className='title'>请输入邀请码</View>
                <View className='search'>
                  <Image className='search-img' src='https://video-img.fyshark.com/1683600195067ahjdklj.png'></Image>
                  <Input className='search-input' onInput={e => (this.search(e))} type='text' placeholder='请输入邀请码' focus />
                </View>
              </View>
              :
              <View>
                <View className='title'>我的邀请码：</View>
                <View className='code'>{this.state.my_code}</View>
              </View>
          }
          <View className='console'>
            <View className='console-button' onClick={e => (this.teamEnqueue())}>{this.state.my_role_status == 0 ? "确定" : '一键复制'}</View>
          </View>
          <View className='user-info'>
            <View className='identity'>我的角色：{this.state.my_role_name}</View>
            {
              this.state.my_role_status != 1 &&
              <View className='status'>我的邀请状态：{this.state.my_role_status == 0 ? '未邀请' : '已加入'}</View>
            }
            {
              this.state.my_role_status == 1 &&
              <View className='status'>我的团队人数：{this.state.team_sum}人</View>
            }
          </View>
        </View>
      </View>
    )
  }
}
