import { Component } from 'react'
import { View, Text, Button, Image, scrollView, Input } from '@tarojs/components'
import * as api from '../../../../service/index'
import tool from '../../../../common/tool'
import Taro, { } from '@tarojs/taro'
import './index.less'

export default class collection extends Component {
  state = {
    userInfo: {},
    purchaseList: [],
    selectVip: 0,//当前选择的充值
    isIos: false,
    isOpen: false,//是否打开口令填写弹窗
    code: '',//口令
    pay_status: 1,//是否绑定口令
  }

  componentWillMount () {
    let that = this
    this.getShopList()
    this.getUserInfo()
    Taro.getSystemInfo({
      success: function (res) {
        if (res.platform != "android") {
          that.setState({
            isIos: true
          })
        }
      }
    })
  }
  componentDidShow () {
  }
  getUserInfo () {
    api.getUserInfo().then(res => {
      Taro.hideLoading()
      if (res.code == 200) {
        this.setState({
          userInfo: res.data
        })
      }
    })
  }
  getShopList () {
    api.getShopList().then(res => {
      if (res.code == 200) {
        this.setState({
          purchaseList: res.data.vip_list,
          pay_status: res.data.pay_status
        })
      }
    })
  }
  //充值
  toOrder () {
    if (this.state.purchaseList[this.state.selectVip].ios_status == 0) {
      if (this.state.isIos) {
        Taro.showToast({
          title: 'ios暂不支持充值',
          icon: 'none',
          duration: 2000
        })
        return
      }
    }
    let that = this
    let item = this.state.purchaseList[this.state.selectVip]
    if (process.env.TARO_ENV === 'tt') {
      Taro.showLoading({
        title: '加载中...',
      })
      api.ttCreateOrder({ pay_info_id: item.id, book_id: -1 }).then(res => {
        if (res.code == 200) {
          Taro.hideLoading()
          tt.pay({
            orderInfo: {
              order_id: res.data.order_id,
              order_token: res.data.order_token
            },
            service: 5,
            success (item) {
              if (item.code == 0) {
                that.getUserInfo()
                setTimeout(() => {
                  that.getUserInfo()
                }, 2000);
                // 支付成功处理逻辑，只有res.code=0时，才表示支付成功
                // 但是最终状态要以商户后端结果为准
              }
            },
            fail (item) {
              // 调起收银台失败处理逻辑
            },
          });
        }
      })
    } else if (process.env.TARO_ENV === 'weapp') {
      Taro.getSystemInfo({
        success: function (res) {
          Taro.showLoading({
            title: '加载中...',
          })
          api.createOrder({ shop_id: item.id }).then(res => {
            if (res.code == 200) {
              Taro.hideLoading()
              Taro.requestPayment({
                timeStamp: res.data.timeStamp,
                nonceStr: res.data.nonceStr,
                package: res.data.package,
                signType: res.data.signType,
                paySign: res.data.paySign,
                success: function (res) {
                  // console.log(res);
                  //添加2s延迟在刷新数据
                  setTimeout(() => {
                    that.getUserInfo()
                  }, 2000);
                },
                fail: function (err) {
                  try {
                    const res = Taro.getSystemInfoSync()
                    console.log(res, 'iphone=====');
                  } catch (e) {
                  }
                }
              })
            }
          })
        }
      })
    }

  }
  selectVip (item, index) {
    this.setState({
      selectVip: index
    })
  }
  openCode () {
    this.setState({
      isOpen: true
    })
  }
  searchCode (e) {
    this.setState(
      {
        code: e.detail.value
      }
    )
  }
  cancel () {
    this.setState({
      isOpen: false
    })
  }
  determine () {
    api.getCheckoutBookCode({ input_str: this.state.code }).then(res => {
      if (res.code == 200) {
        this.getShopList()
        this.getUserInfo()
        this.setState({
          isOpen: false
        })
        Taro.showToast({
          title: `已获取折扣`,
          icon: 'none',
          duration: 2000
        })
      } else {
        Taro.showToast({
          title: res.msg,
          icon: 'none',
          duration: 2000
        })
      }
    })
  }

  render () {
    return (
      <View className='mine'>
        <View className='mine-content'>
          {
            this.state.userInfo.is_vip == 1 &&
            <View className='user-vip-banner-have'>
              <View className='vip-banner-have-left'>
                <Image className='vip-banner-img' src='https://video-img.fyshark.com/1683860337987f-vip3.png'></Image>
                <View className='vip-banner-tips'>已开通会员，有效期至：{tool.formattedDate(this.state.userInfo.time_is_vip)}</View>
              </View>
            </View>
          }
          <View className='vip-tips'>
            <View className='tips-title'>会员权益</View>
            <View className='tips-content'>
              <View className='tips-left'>
                <View className='tips-img'>
                  <Image className='tips-icon' src='https://video-img.fyshark.com/1683709602205akkhs.png'></Image>
                </View>
                <View className='tips-text'>
                  <View className='text-title'>免费阅读</View>
                  <View className='text-introduce'>付费章节享受免费阅读</View>
                </View>
              </View>
              <View className='tips-right'>
                <View className='tips-img'>
                  <Image className='tips-icon' src='https://video-img.fyshark.com/1683709622282slljl.png'></Image>
                </View>
                <View className='tips-text'>
                  <View className='text-title'>新书优先阅读</View>
                  <View className='text-introduce'>新书会员可优先阅读</View>
                </View>
              </View>
            </View>
          </View>
          <View className='purchase'>
            <View className='purchase-title'>购买会员</View>
            {
              this.state.pay_status == 0 &&
              <View className='active' onClick={e => (this.openCode())}>
                <Image className='active-img' src='https://video-img.fyshark.com/1685349084726icon.png' mode='widthFix'></Image>
              </View>
            }
            <View className='purchase-list'>
              {
                this.state.purchaseList.map((item, index) => (
                  <View className={this.state.selectVip == index ? 'purchase-info-active' : 'purchase-info'}
                    key={index}
                    onClick={e => (this.selectVip(item, index))}
                  >
                    {
                      item.tag && item.tag.length > 0 &&
                      < View className='purchase-tips'>{item.tag}</View>
                    }
                    <View className='purchase-title'>{item.title}</View>
                    <View className='purchase-money'><View className='purchase-money-tip'>￥</View>{item.money / 100}</View>
                    <View className='purchase-oldMoney'>￥{item.coin / 100}元/周</View>
                    <View className='purchase-text'>
                      <View className='purchase-button'>{item.sub_title}</View>
                    </View>
                  </View>
                ))
              }
            </View>
          </View>
          <View className='payInfo' onClick={e => (this.toOrder())}>
            立即支付
          </View>
          <View className='prompt'>
            <View className='prompt-title'>温馨提示</View>
            <View className='prompt-text'>1.未满18周岁的用户请谨慎购买；</View>
            <View className='prompt-text'>2.VIP会员属于虚拟商品，一旦购买不做退换；</View>
            <View className='prompt-text'>3.如有问题请在我的页面联系客服。</View>
          </View>
        </View>
        {
          this.state.isOpen &&
          <View className='information'>
            <View className='information-content'>
              <View className='information-title'>
                请输入口令码
              </View>
              <View className='search'>
                <Input className='search-input' onInput={e => (this.searchCode(e))} type='text' placeholder='请输入口令码' focus />
              </View>
              <View className='information-console'>
                <View className='cancel' onClick={e => (this.cancel())}>取消</View>
                <View className='determine' onClick={e => (this.determine())}>确定</View>
              </View>
            </View>
          </View>
        }
      </View >
    )
  }
}
